version: "3.8"


services:

# todo : feedback on integration to @Aris
# - api key should be passed by env https://gitlab.com/deepcube-draft/wp2-deepcube-platform/visualization-tools-for-social-media/DeepCube_WebApp/-/blob/main/DeepCube_WebAPP/utils.py#L11
# - remove secret files with values
# - remove secrets from https://gitlab.com/deepcube-draft/wp2-deepcube-platform/visualization-tools-for-social-media/DeepCube_SocialMediaAPI/-/blob/main/DeepCube_API/utils.py
# - check https://gitlab.com/deepcube-draft/wp2-deepcube-platform/visualization-tools-for-social-media/DeepCube_WebApp/-/blob/main/DeepCube_Visualization/settings.py#L95
# - store https://gitlab.com/deepcube-draft/wp2-deepcube-platform/visualization-tools-for-social-media/DeepCube_SocialMediaAPI/-/blob/main/RESTAPI/static/api-keys.json not in file


# todo : check 502 badgateway
  social-media-api:
    image: "registry.gitlab.com/deepcube-draft/wp2-deepcube-platform/visualization-tools-for-social-media/deepcube_socialmediaapi:{{ deepcube_social_media_api_version }}"
    networks:
      - {{ caddy_network }}
    environment:
      DJANGO_SECRET_KEY: "{{ deepcube_social_media_api_secret_key }}"
      DJANGO_DEBUG: "{{ 'True' if deepcube_social_media_api_debug else 'False' }}"
      DJANGO_ALLOWED_HOSTS: "{{ deepcube_social_media_api_allowed_hosts|join(',') }}"
      DJANGO_CORS_ORIGIN_ALLOW_ALL: "{{  'True' if deepcube_social_media_api_allowed_cors_all else 'False' }}"
      DJANGO_CORS_ORIGIN_WHITELIST: "{{ deepcube_social_media_api_allowed_cors_whitelist|join(',') }}"
      DJANGO_MONGO_USER: "{{ deepcube_social_media_api_mongo_user }}"
      DJANGO_MONGO_PASS: "{{ deepcube_social_media_api_mongo_pass }}"
      DJANGO_MONGO_DBNAME: "{{ deepcube_social_media_api_mongo_dbname }}"
    deploy:
      mode: replicated
      replicas: {{ deepcube_social_media_replicas }}
      restart_policy:
        condition: any
        delay: 5s
        window: 45s
        max_attempts: 5
      placement:
        constraints:
          - node.labels.{{ deepcube_social_media_node_tag }} == true
        preferences:
          - spread: node.id
      labels:
        caddy: "{{ deepcube_social_media_domain }}"

        caddy.1_redir: "/api /api/"
        caddy.2_handle_path: "/api/*"

        # security labels
        caddy.2_handle_path.1_header.-Server: ""
        caddy.2_handle_path.1_header.-X-Powered-By: ""
        caddy.2_handle_path.1_header.Permissions-Policy: "\"accelerometer=(), camera=(), geolocation=(), gyroscope=(), magnetometer=(), microphone=(), payment=(), usb=()\"" # see best practices https://github.com/w3c/webappsec-permissions-policy/blob/master/features.md, https://developer.mozilla.org/en-US/docs/Web/HTTP/Feature_Policy
        caddy.2_handle_path.1_header.Referrer-Policy: "same-origin"
        caddy.2_handle_path.1_header.X-Content-Type-Options: "nosniff"
        caddy.2_handle_path.1_header.X-Frame-Options: "DENY"
        caddy.2_handle_path.1_header.X-XSS-Protection: "\"1; mode=block\""


        # ip filter auth & reverse proxy conf
        caddy.2_handle_path.2_@ipfilter.remote_ip: "{{ deepcube_social_media_allowed_ips|join(' ') }} 127.0.0.1"

        # apply ip filter
        caddy.2_handle_path.3_handle: "@ipfilter"

        # try to match filter for a reverse proxy to upstream (eventually add load balancing etc) 
        caddy.2_handle_path.3_handle.1_reverse_proxy: "{% raw %}{{upstreams 8000}}{% endraw %}"
        caddy.2_handle_path.3_handle.1_reverse_proxy.lb_policy: "round_robin"


        # or reject
        caddy.2_handle_path.4_respond: "`Origin not allowed` 403"

 # todo : api key should be passed by env
 # todo : remove secrets from files in docker apps
  social-media-app:
    image: "registry.gitlab.com/deepcube-draft/wp2-deepcube-platform/visualization-tools-for-social-media/deepcube_webapp:{{ deepcube_social_media_app_version }}"
    networks:
      - {{ caddy_network }}
    environment:
      DJANGO_SECRET_KEY: "{{ deepcube_social_media_app_secret_key }}"
      DJANGO_DEBUG: "{{  'True' if  deepcube_social_media_app_debug else 'False' }}"
      DJANGO_ALLOWED_HOSTS: "{{ deepcube_social_media_app_allowed_hosts|join(',') }}"
      DJANGO_CORS_ORIGIN_ALLOW_ALL: "{{ 'True' if deepcube_social_media_app_allowed_cors_all else 'False' }}"
      DJANGO_CORS_ORIGIN_WHITELIST: "{{ deepcube_social_media_app_allowed_cors_whitelist|join(',') }}"
      DJANGO_API_IP: "{{ deepcube_social_media_app_api_ip }}"
    deploy:
      mode: replicated
      replicas: {{ deepcube_social_media_replicas }}
      restart_policy:
        condition: any
        delay: 5s
        window: 45s
        max_attempts: 5
      placement:
        constraints:
          - node.labels.{{ deepcube_social_media_node_tag }} == true
        preferences:
          - spread: node.id
      labels:
        caddy: "{{ deepcube_social_media_domain }}"

        # hsts headers (see https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Strict-Transport-Security)
        caddy.0_header.Strict-Transport-Security: "\"max-age=63072000; includeSubDomains; preload\""
        

        caddy.2_@uimatcher.not.path: "/api*"
        caddy.3_handle: "@uimatcher"

        # security labels
        caddy.3_handle.1_header.-Server: ""
        caddy.3_handle.1_header.-X-Powered-By: ""
        caddy.3_handle.1_header.Permissions-Policy: "\"accelerometer=(), camera=(), geolocation=(), gyroscope=(), magnetometer=(), microphone=(), payment=(), usb=()\"" # see best practices https://github.com/w3c/webappsec-permissions-policy/blob/master/features.md, https://developer.mozilla.org/en-US/docs/Web/HTTP/Feature_Policy
        caddy.3_handle.1_header.Referrer-Policy: "same-origin"
        caddy.3_handle.1_header.X-Content-Type-Options: "nosniff"
        caddy.3_handle.1_header.X-Frame-Options: "DENY"
        caddy.3_handle.1_header.X-XSS-Protection: "\"1; mode=block\""


        # ip filter auth & reverse proxy conf
        caddy.3_handle.2_@ipfilter.remote_ip: "{{ deepcube_social_media_allowed_ips|join(' ') }} 127.0.0.1"

        # apply ip filter
        caddy.3_handle.3_handle: "@ipfilter"

        # try to match filter for a reverse proxy to upstream (eventually add load balancing etc) 
        caddy.3_handle.3_handle.1_reverse_proxy: "{% raw %}{{upstreams 8001}}{% endraw %}"
        caddy.3_handle.3_handle.1_reverse_proxy.lb_policy: "round_robin"
        caddy.3_handle.3_handle.1_reverse_proxy.health_uri: "/"
        caddy.3_handle.3_handle.1_reverse_proxy.health_interval: "5s"


        # or reject
        caddy.3_handle.4_respond: "`Origin not allowed` 403"

networks:
   {{ caddy_network }}:
     external: true
